import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;

class ImageCanvas extends Panel implements MouseListener,MouseMotionListener {
    SEISAN pappy;
    Image image,offImage;
    boolean trueSizeKnown = false;
    Dimension minSize;
    int w, h;
    //!!!!!
    int cindexp=0; // current index of Polygon being created;
    double centerlon=0.0, centerlat=0.0, halflon=0.0, halflat=0.0;
    int x1,y1,x2,y2,tx1,tx2,ty1,ty2;
    double momx,momy;
    String url;
    //java.applet.AppletContext showseit;
    Graphics offGraphics;
    boolean donerectangle=false;
    boolean user_interaction = false;
    String width="";
    String height="";
    int initWidth,initHeight;
    int scale = 2;
    int previousItem=-1;
    
   

    public ImageCanvas ( SEISAN parent, int initialWidth, int initialHeight,boolean interactive) {

       pappy = parent;
       tx1=tx2=ty1=ty2=0;
       user_interaction = interactive;
       width = (new Integer(initialWidth)).toString();
       height = (new Integer(initialHeight)).toString();
       initWidth = initialWidth;
       initHeight = initialHeight;
       
       
       //showseit=pappy.AppContext.getAppletContext();

       w = initialWidth+1;
       h = initialHeight+1;

       minSize = new Dimension(w,h);

       addMouseListener(this);
       addMouseMotionListener(this);

       showOverview();

		
	}


    public String[] SelLatLonString() {

       String latlon[]=new String[4];

       latlon[0]=new Float(centerlat-halflat).toString();
       latlon[2]=new Float(centerlat+halflat).toString();

       latlon[1]=new Float(centerlon-halflon).toString();
       latlon[3]=new Float(centerlon+halflon).toString();

       return latlon;
    }

    public void showOverview() {

       x1=0;
       x2=0;
       y1=0;
       y2=0;
       centerlon=(pappy.lonmax+pappy.lonmin)/2;
       centerlat=(pappy.latmax+pappy.latmin)/2;
       halflon = (pappy.lonmax - pappy.lonmin)/2;
       halflat = (pappy.latmax - pappy.latmin)/2;       
       //url= pappy.mapserver+"IMGWORLD0.gif";
       url= pappy.INIT_MAP_FILE;
       System.out.println(url);
       image = getToolkit().getImage(url);
       //image=retrImage(url);
       repaint();

    }

    
    public void zoomin() {
       
       centerlat=YtoLatLon(y1);
       centerlon=XtoLatLon(x1);
       
       halflat=halflat/scale;
       halflon=halflon/scale;

       
            
       if ((centerlat+halflat)>pappy.latmax) {
          centerlat=pappy.latmax-halflat;
       }
       if ((centerlat-halflat)<pappy.latmin) {
          centerlat=pappy.latmin+halflat;
       }
       if ((centerlon+halflon)>pappy.lonmax) {
          centerlon=pappy.lonmax-halflon;
       }
       if ((centerlon-halflon)<pappy.lonmin) {
          centerlon=pappy.lonmin+halflon;
       }
       
        
          pappy.update();
       
          
          
       
	      //image=retrImage(url);
          
          //System.out.println("url: "+ url);
      

    }

    public void drawline() {
     // draw a line of the polygon   
      if (cindexp > 0) 
       if ( (Math.abs(LontoX(pappy.SetPAR.POLYGONX[cindexp])-LontoX(pappy.SetPAR.POLYGONX[0]))<5)
          && (Math.abs(LattoY(pappy.SetPAR.POLYGONY[cindexp])-LattoY(pappy.SetPAR.POLYGONY[0]))<5) ) {
          EndPoly();
          return;
          }   
       else
       this.getGraphics().drawLine(LontoX(pappy.SetPAR.POLYGONX[cindexp-1]),LattoY(pappy.SetPAR.POLYGONY[cindexp-1]), 
                                   LontoX(pappy.SetPAR.POLYGONX[cindexp]),LattoY(pappy.SetPAR.POLYGONY[cindexp]));                                   
        ++cindexp;                                              
    }    
    
    public void zoomout() {
        
       centerlat=YtoLatLon(y1);
       centerlon=XtoLatLon(x1);
       halflat=halflat*scale;
       halflon=halflon*scale;

          if (((centerlat+halflat)> pappy.latmax) ||
             ((centerlat-halflat)< pappy.latmin) ||
	     (centerlon+halflon)> pappy.lonmax ||
	     (centerlon-halflon)< pappy.lonmin ) {

             centerlon=(pappy.lonmax+pappy.lonmin)/2;
             centerlat=(pappy.latmax+pappy.latmin)/2;
             halflon=(pappy.lonmax-pappy.lonmin)/2;
             halflat=(pappy.latmax-pappy.latmin)/2;
         }
        
          pappy.update();
          
	      //image=retrImage(url);

          //System.out.println("url: "+ url);
          
    }

    
  
    public Image retrImage(String url) {
         
       try {
          System.out.println(url);
         return getToolkit().getImage(new URL(url));
         //return getToolkit().getImage(new URL("http://www.ifjf.uib.no/IMG14599.gif"));
       } catch (MalformedURLException e) {
          System.out.println("error getting image");
       }

       return null;
    }

    public int LontoX(double lon){
        int x;        
        double factor = initWidth/(2*halflon);
        x = (new Double((lon - centerlon + halflon)*factor)).intValue();
        return x;
    }
    
    public int LattoY(double lat) {
        int y;
        double factor = initHeight/(2*halflat);
        y = (new Double((lat - centerlat - halflat)*factor)).intValue();
        return -y;
    }
    
    public double XtoLatLon(int val) {
	   double xr;
           xr=(new Integer(val)).floatValue()/initWidth*halflon*2+centerlon-halflon;
	   return(xr);
    }

    public double YtoLatLon(int val) {
	   double yr;
           yr=(centerlat+halflat)-(((new Integer(val)).floatValue())/initHeight*halflat*2);
	   return(yr);
    }


    public void mousePressed(MouseEvent e) {
    }

    public void mouseReleased(MouseEvent e) {
    }
    public void mouseDragged(MouseEvent e) {
    }
    
    public void mouseMoved(MouseEvent e) {
       momx=XtoLatLon(e.getX());
       momy=YtoLatLon(e.getY());      
       pappy.updateCursor(momx,momy);
       if(pappy.busy) {
        this.setCursor(new Cursor(Cursor.WAIT_CURSOR));
        return;
       } 
       if(pappy.MapClickChoice.getSelectedIndex()<2)
        this.setCursor(new Cursor(Cursor.HAND_CURSOR));
       else if(pappy.MapClickChoice.getSelectedIndex()==3)
        this.setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
       else
        this.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
    }
    
    public void mouseEntered(MouseEvent e) {
    }
    
    public void mouseClicked(MouseEvent e) {
       if(!user_interaction) return; 
       x1 = e.getX();
       y1 = e.getY();
       if (pappy.MapClickChoice.getSelectedIndex()==0) {
          zoomin();
       }
       if (pappy.MapClickChoice.getSelectedIndex()==1) {
          zoomout();
       }
       if (pappy.MapClickChoice.getSelectedIndex()==3) {
         if (pappy.SetPAR.NPOLY > 0 ) { // remove the previous polygon
            pappy.SetPAR.NPOLY = 0;
            update(this.getGraphics());
         }  
          pappy.SetPAR.POLYGONX[cindexp]=XtoLatLon(x1);
          pappy.SetPAR.POLYGONY[cindexp]=YtoLatLon(y1);
          this.getGraphics().drawLine(x1-5, y1, x1+5, y1);
          this.getGraphics().drawLine(x1, y1-5, x1, y1+5);
          drawline();
          
       }
       
       if (pappy.MapClickChoice.getSelectedIndex()==2) {
         getItems(x1,y1);
         plotselected();
       }
       
    }
    public void mouseExited(MouseEvent e) {
    }
    public void destroy() {
       removeMouseListener(this);
       removeMouseMotionListener(this);
       System.exit(0);
    }

    public void paint(Graphics g) {

        g.setColor(getBackground());
        g.fillRect(0, 0, w, h);
        g.setColor(Color.black);

	 g.setColor(getForeground());
	//if(!user_interaction) g.setXORMode(Color.magenta);
	 g.setPaintMode();

        //offGraphics.drawString("Wait, loading map...",250,250);

        //!!!!!
        if (pappy.reset || !user_interaction ) {
            //offGraphics.drawImage(image, 0, 0,this);
            g.drawImage(image, 0, 0,this);
        } else {
           for (int j=0;j<pappy.max_layers;++j) {
              if (pappy.selectedimg[j]!=null ) {
                 //offGraphics.drawImage(pappy.selectedimg[j], 0, 0, this);
                 g.drawImage(pappy.selectedimg[j], 0, 0, this);
              }
           }
        }
        // draw the image on screen
        /*if (offImage != null) {
	     g.drawImage(offImage, 0, 0, this);
	   }*/

        if (!user_interaction) {            
           x1 = LontoX(pappy.imagepan.centerlon-pappy.imagepan.halflon);
           x2 = LontoX(pappy.imagepan.centerlon+pappy.imagepan.halflon);
           y2 = LattoY(pappy.imagepan.centerlat-pappy.imagepan.halflat);
           y1 = LattoY(pappy.imagepan.centerlat+pappy.imagepan.halflat);
           g.setColor(Color.red);
           g.drawRect(x1,y1,(x2-x1)-1,(y2-y1)-1);         
        } else
         PlotItems(g,-1,true);
         DrawPolygon();
//        pappy.initCornerWindow();
//        pappy.setScaleLabel();
        
    }

    public void update(Graphics g) {
      paint(g);
    }
    
    void plotselected() {
        if( previousItem >= 0 )
         PlotItems(this.getGraphics(),previousItem,true);
        int i=pappy.JList1.getSelectedIndex();
        if(i>=0)
         PlotItems(this.getGraphics(),i,false);
        previousItem=i; 
    }    
    
    void PlotItems(Graphics g,int item,boolean previous) {
        int n = pappy.JList1.getItemCount();
        int i,j,k,l;
        double x,y;
        String cad,cadx,cady;
        if(item!=-1) {
            n = item+1;
        } else
           item=0;
        for(i=item; i<n; ++i) {
            g.setColor(Color.red);
            cad = pappy.JList1.getItem(i);
              j=23;
              cady = cad.substring(j, j+7);
              cadx = cad.substring(j+7,j+15);
              if( (cadx.trim().length()>0) && (cady.trim().length()>0) ) {
              y = (new Double(cady)).doubleValue();
              x = (new Double(cadx)).doubleValue();
              g.drawOval(LontoX(x)-5, LattoY(y)-5, 10, 10);
              if( previous )
               g.setColor(Color.black);
              else 
               g.setColor(Color.white);
              g.fillOval(LontoX(x)-5, LattoY(y)-5, 10, 10);
              } 
        }    
        
    }    
    
    void getItems(int x,int y) {
        int n = pappy.JList1.getItemCount();
        int i,j;
        int x1,x2;
        int y1,y2;
        double xval,yval;
        String cad,cad1;
        for(i=0; i<n; ++i) {
            cad = pappy.JList1.getItem(i);
              j=23;
              cad1 = cad.substring(j, j+7).trim();
              if( cad1.length() > 0 ) {
              yval = (new Double(cad1)).doubleValue();
              xval = (new Double(cad.substring(j+7,j+15))).doubleValue();
              if( ((LontoX(xval)-5)<x) && ((LontoX(xval)+5)>x)
                && ((LattoY(yval)-5)<y) && ((LattoY(yval)+5)>y)) {
                pappy.JList1.select(i);
                pappy.JList1.makeVisible(i);
              }  
             } 
        }    
    }
   
        
    void EndPoly()
      {
		// ending the polygon creation
		  OKDialog.createOKDialog("Polygon ended");
		  pappy.SetPAR.NPOLY = cindexp;
	      this.getGraphics().drawLine(LontoX(pappy.SetPAR.POLYGONX[cindexp-1]),LattoY(pappy.SetPAR.POLYGONY[cindexp-1]), 
                                   LontoX(pappy.SetPAR.POLYGONX[0]),LattoY(pappy.SetPAR.POLYGONY[0]));                             
          cindexp = 0;                                   
	  }
	  
	void DrawPolygon() {
	  Graphics g = this.getGraphics();
	  int j;
	  for( j=0; j<pappy.SetPAR.NPOLY-1; ++j) {
	    g.drawLine(LontoX(pappy.SetPAR.POLYGONX[j]),LattoY(pappy.SetPAR.POLYGONY[j]),LontoX(pappy.SetPAR.POLYGONX[j+1]),LattoY(pappy.SetPAR.POLYGONY[j+1]));
	  }
	  g.drawLine(LontoX(pappy.SetPAR.POLYGONX[j]),LattoY(pappy.SetPAR.POLYGONY[j]),LontoX(pappy.SetPAR.POLYGONX[0]),LattoY(pappy.SetPAR.POLYGONY[0]));
	}    
	  
   }  





